Q:给定一个整数数组 nums 和一个目标值 target,请你在该数组中找出和为目标值的那 两个 整数,并返回他们的数组下标。
你可以假设每种输入只会对应一个答案。但是,你不能重复利用这个数组中同样的元素。
示例:
给定 nums = [2, 7, 11, 15], target = 9
因为 nums[0] + nums[1] = 2 + 7 = 9
所以返回 [0, 1]
解法一,暴力解法:遍历每个元素 xx,并查找是否存在一个值与target−x 相等的目标元素
class Solution {
public int[] twoSum(int[] nums, int target) {
for(int i=0;i<nums.length;i++){
for (int j = i+1; j < nums.length; j++) {
if (nums[j] == target-nums[i]){
return new int[] {i,j};
}
}
}
throw new IllegalArgumentException("No two sum solution");
}
}
复杂度分析:
时间复杂度:O(n^2);对于每个元素,我们试图通过遍历数组的其余部分来寻找它所对应的目标元素,这将耗费 O(n) 的时间。因此时间复杂度为 O(n^2)。
空间复杂度:O(1)。
解法二:二遍哈希表
class Solution {
public int[] twoSum(int[] nums, int target) {
Map<Integer,Integer> map=new HashMap();
for (int i = 0; i < nums.length; i++) {
map.put(nums[i],i);
}
for(int i=0;i<nums.length;i++){
int temp=target-nums[i];
if (map.containsKey(temp) && map.get(temp) != i){
return new int[]{map.get(temp),i};
}
}
throw new IllegalArgumentException("No two sum solution");
}
}
复杂度分析:
时间复杂度:O(n), 我们把包含有 n个元素的列表遍历两次。由于哈希表将查找时间缩短到 O(1),所以时间复杂度为 O(n)。
空间复杂度:O(n), 所需的额外空间取决于哈希表中存储的元素数量,该表中存储了 n 个元素。
解法三:一遍哈希表
class Solution {
public int[] twoSum(int[] nums, int target) {
Map<Integer,Integer> map=new HashMap<Integer,Integer>();
for(int i=0;i<nums.length;i++){
int temp=target-nums[i];
if (map.containsKey(temp)){
return new int[]{map.get(temp),i};
}
map.put(nums[i],i);
}
throw new IllegalArgumentException("No two sum solution");
}
}
复杂度分析:
时间复杂度:O(n), 我们只遍历了包含有 n 个元素的列表一次。在表中进行的每次查找只花费 O(1)的时间。
空间复杂度:O(n), 所需的额外空间取决于哈希表中存储的元素数量,该表最多需要存储 n 个元素。
解法四:排序+双指针
public int[] twoSum(int[] nums, int target) {
int[] tmp1 = new int[nums.length];
System.arraycopy(nums, 0, tmp1, 0, nums.length);
Arrays.sort(nums);
int headValue = 0;
int endValue = 0;
int head = 0;
int end = nums.length - 1;
while (head < end) {
if (nums[head] + nums[end] > target) {//比结果大,尾指针前移
end--;
} else if (nums[head] + nums[end] < target) {//比结果小,头指针前移
head++;
} else if (nums[head] + nums[end] == target) {
headValue = head;
endValue = end;
break;
}
}
int resultkey = 0, resultValue = 0;
boolean haskey = false;//解决数组存在重复得元素
for (int i = 0; i < tmp1.length; i++) {
if (nums[headValue] == tmp1[i] && !haskey) {
resultkey = i;
haskey = true;
} else if (nums[endValue] == tmp1[i]) {
resultValue = i;
}
}
return new int[]{resultkey, resultValue};
}
复杂度分析:
时间复杂度:O(n), 对数组排序时间+双指针遍历最糟糕得情况(n)+最终查找元素(n)
空间复杂度:O(n), 所需的额外空间取决于哈希表中存储的元素数量,该表最多需要存储 n 个元素。复制了一份
来源:力扣(LeetCode)
链接:https://leetcode-cn.com/problems/two-sum
著作权归领扣网络所有。商业转载请联系官方授权,非商业转载请注明出处。